## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 26;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond selinux 1
%global selinux_variants targeted
%global selinuxtype targeted
%global selinux_package_dir %{_datadir}/selinux/packages

Name:           localkdc
Version:        0.0.1
Release:        %autorelease -b 8
Summary:        A local KDC based on MIT Kerberos

License:        MIT
URL:            https://gitlab.com/cryptomilk/localkdc
Source0:        %{name}-%{version}.tar.gz

BuildRequires:  cmake
BuildRequires:  gcc
BuildRequires:  pkgconfig(kdb)
BuildRequires:  pkgconfig(kirmes)
BuildRequires:  systemd-rpm-macros

Requires:       bash
Requires:       gawk
Requires:       hostname
Requires:       krb5-server
Requires:       certmonger
%if %{with selinux}
Requires:       (%{name}-selinux if selinux-policy-%{selinuxtype})
%endif

Requires(post): (systemd-standalone-tmpfiles or systemd)
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units


%description
A local KDC using MIT Kerberos.


%if %{with selinux}
%package selinux
Summary:        SELinux support for %{name}

BuildRequires:  selinux-policy-devel

Requires:       %{name} = %{version}-%{release}
Requires:       selinux-policy-%{selinuxtype}
Requires(post): selinux-policy-%{selinuxtype}

%description selinux
SELinux support for %{name}
#endif with selinux
%endif


%prep
%autosetup -p1


%build
%cmake \
    -DCMAKE_INSTALL_RUNSTATEDIR=/run \
    -DCMAKE_INSTALL_LOCALSTATEDIR=/var
%cmake_build

pushd selinux
for SELINUXVARIANT in %{selinux_variants}; do
    make -f /usr/share/selinux/devel/Makefile %{name}.pp
    mv -v %{name}.pp %{name}-${SELINUXVARIANT}.pp
done
popd


%install
%cmake_install

install -d -m 0755 %{buildroot}%{_sysconfdir}/localkdc
install -d -m 0755 %{buildroot}%{_var}/kerberos/localkdc

install -d -m 0755 %{buildroot}%{_tmpfilesdir}
echo "d /run/localkdc  755 root root" > %{buildroot}%{_tmpfilesdir}/localkdc.conf

%if %{with selinux}
# Install the SELinux module(s).
rm -fv selinux-files.txt

for SELINUXVARIANT in %{selinux_variants}; do
    install -d -m 755 %{buildroot}%{selinux_package_dir}/${SELINUXVARIANT}
    bzip2 selinux/%{name}-${SELINUXVARIANT}.pp
    MODULE_PATH=%{selinux_package_dir}/${SELINUXVARIANT}/%{name}.pp.bz2
    install -p -m 644 selinux/%{name}-${SELINUXVARIANT}.pp.bz2 \
      %{buildroot}${MODULE_PATH}

    echo ${MODULE_PATH} >> selinux-files.txt
done
#endif with selinux
%endif


%post
%tmpfiles_create %{_tmpfilesdir}/localkdc.conf
%systemd_post localkdc.service localkdc.socket

%preun
%systemd_preun localkdc.service localkdc.socket

%postun
%systemd_postun localkdc.service localkdc.socket

%if %{with selinux}
%pre selinux
for SELINUXVARIANT in %{selinux_variants}; do
    %selinux_relabel_pre -s ${SELINUXVARIANT}
done

%post selinux
for SELINUXVARIANT in %{selinux_variants}; do
    MODULE_PATH=%{selinux_package_dir}/${SELINUXVARIANT}/%{name}.pp.bz2
    %selinux_modules_install -s ${SELINUXVARIANT} ${MODULE_PATH}
done

%postun selinux
if [ $1 -eq 0 ]; then
    for SELINUXVARIANT in %{selinux_variants}; do
        %selinux_modules_uninstall -s ${SELINUXVARIANT} %{name}
    done
fi

%posttrans selinux
for SELINUXVARIANT in %{selinux_variants}; do
    %selinux_relabel_post -s ${SELINUXVARIANT}
done
#endif with selinux
%endif


%files
%license LICENSE
%doc README.md
%dir %{_sysconfdir}/localkdc
%{_libdir}/krb5/plugins/kdb/kuserdb.so
%{_sbindir}/localkdc-kadmin
%{_sbindir}/localkdc-kinit
%{_sbindir}/localkdc-setup
%{_sbindir}/localkdc-useradd
%dir %{_datadir}/localkdc
%{_datadir}/localkdc/localkdc-utils.sh
%{_datadir}/localkdc/templates
%{_tmpfilesdir}/localkdc.conf
%{_unitdir}/localkdc.socket
%{_unitdir}/localkdc.service
%dir %{_var}/kerberos/localkdc

%if %{with selinux}
%files selinux -f selinux-files.txt
%endif


%changelog
## START: Generated by rpmautospec
* Fri Jun 27 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-33
- Fix selinux

* Fri Jun 20 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-32
- Fix an infinite loop

* Fri May 16 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-31
- Fix localkdc-setup

* Fri May 16 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-30
- Fix possible recursion in kdb with localhost

* Fri May 16 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-29
- Build with debuginfo package for kdb module

* Fri May 16 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-28
- Fix build because of missing errno.h

* Fri May 16 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-27
- Add support for IP and dynamic DNS aliases

* Thu Apr 17 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-26
- Use app-id derived from machine-id as localkdc realm
- Added localkdc-kinit

* Thu Apr 10 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-25
- Fix issues with localkdc-useradd

* Thu Apr 10 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-24
- Fix localkdc-useradd
- This goes to changelog

* Tue Apr 08 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-23
- Update for new localkdc realm option

* Mon Apr 07 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-22
- Require preauth

* Mon Apr 07 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-21
- Fix default realm

* Wed Apr 02 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-20
- Add userdb support

* Wed Apr 02 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-19
- gitignore

* Wed Mar 12 2025 Andreas Schneider <asn@redhat.com> - 0.0.1-18
- foo

* Fri Jan 24 2025 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-15
- New release

* Mon Jan 20 2025 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-14
- Update for alias changes

* Thu Dec 05 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-13
- Updates for kdb api changes

* Wed Dec 04 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-12
- Fix tarball

* Wed Dec 04 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-11
- Don't use kdc_unixsock_listen anymore

* Fri Nov 29 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-10
- update tarball

* Fri Nov 29 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-9
- update tarball

* Fri Nov 29 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-6
- kdb driver

* Fri Nov 29 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-4
- selinux

* Fri Nov 29 2024 Andreas Schneider <asn@cryptomilk.org> - 0.0.1-1
- The big bang!
## END: Generated by rpmautospec
